<template>
  <div style="width: 100%">
    <v-snackbar
      v-model="snackbar.state"
      :color="snackbar.type"
      :timeout="3000"
      multi-line
      top
    >
      {{ snackbar.message }}
      <v-btn flat @click="snackbar.state = false">
        Close
      </v-btn>
    </v-snackbar>

    <!-- ERROR DIALOG -->
    <v-dialog v-model="dialog_error" max-width="500px">
      <v-card>
        <v-card-title>
          <span>ERROR !</span>
          <v-spacer></v-spacer>
        </v-card-title>
        <v-divider></v-divider>
        <div class="ma-3 red--text">{{ msgError }}</div>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" flat @click="dialog_error = false"
            >Tutup</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- END ERROR DIALOG -->


    <v-toolbar color="primary" dark>
      <v-toolbar-title class="white--text"
        >REQUEST PENGELUARAN BARANG</v-toolbar-title
      >
      <v-spacer></v-spacer>
      <v-btn icon @click="openDialogRequest()">
        <v-icon>add_box</v-icon>
      </v-btn>
    </v-toolbar>
    <v-card class="pa-2">
      <v-layout row>
        <v-flex pl-2 xs2>
          <v-menu
            v-model="menuStartDate"
            :close-on-content-click="false"
            transition="scale-transition"
            :nudge-right="40"
            lazy
            offset-y
            max-width="290px"
            min-width="290px"
          >
            <template v-slot:activator="{ on }">
              <v-text-field
                :value="startDateFormatted"
                label="Tanggal Awal"
                readonly
                outline
                hide-details
                v-on="on"
                @blur="dStartDate = deFormatedDate(startDateFormatted)"
              ></v-text-field>
            </template>
            <v-date-picker
              no-title
              v-model="fStartDate"
              @input="menuStartDate = false"
            ></v-date-picker>
          </v-menu>
        </v-flex>
        <v-flex pl-2 xs2>
          <v-menu
          v-model="menuEndDate"
          :close-on-content-click="false"
          transition="scale-transition"
          :nudge-right="40"
          lazy
          offset-y
          max-width="290px"
          min-width="290px"
        >
          <template v-slot:activator="{ on }">
            <v-text-field
              :value="endDateFormatted"
              label="Tanggal Akhir"
              readonly
              outline
              hide-details
              v-on="on"
              @blur="dEndDate = deFormatedDate(endDateFormatted)"
            ></v-text-field>
          </template>
          <v-date-picker
            no-title
            v-model="fEndDate"
            @input="menuEndDate = false"
          ></v-date-picker>
        </v-menu>
        </v-flex>
        <v-flex pl-2 xs2>
          <v-autocomplete
          v-model="fStatus"
          menu-icon="mdi-chevron-down"
          :items="statusOptions"
          item-text="title"
          item-value="value"
          label="Status"
          outline
          hide-details
        ></v-autocomplete>
        </v-flex>
        <v-flex pl-2 xs2>
          <v-text-field
          v-model="fSearch"
          label="Cari..."
          placeholder="NO. RIO"
          outline
          hide-details
        ></v-text-field>
        </v-flex>
        <v-flex pl-2>
          <v-btn
          dark
          color="primary"
          style="min-width: 50px; height: 50px; margin: 0"
          @click="mainTableSearch()"
        >
          <v-icon>search</v-icon>
        </v-btn>
        </v-flex>

      <v-spacer></v-spacer>
      <v-btn v-if="flag == 'G'" @click="goBack()" color="orange darken-2" title="Kembali ke listing pending approval" dark>
        <v-icon dark left>arrow_back</v-icon>Back
      </v-btn>
      </v-layout>
      
    </v-card>
    <v-card class="pa-2 mt-2">
      <v-layout row style="max-height: 600px; overflow: auto">
        <v-flex xs12 pl-2 pr-2 pt-2 pb-2>
          <v-data-table
            :headers="headers"
            :items="mainTable"
            :loading="mainTableLoading"
            hide-actions
            class="elevation-1"
          >
            <template slot="items" slot-scope="props">
              <td
                class="text-xs-center pa-2"
                v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                @click="selectMe(props.item)"
              >
                <div
                  style="
                    display: flex;
                    flex-direction: column;
                    align-items: center;
                  "
                >
                  {{ props.item.rioNumber }}
                  <!-- <v-chip small style="border-radius: 5px; flex-grow: 0">
                    {{ props.item.prRequestedBy }}
                  </v-chip> -->
                </div>
              </td>
              <td
                class="text-xs-left pa-2"
                v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                @click="selectMe(props.item)"
              >
                <div class="date-type-table">
                  <span>

                    {{
                      deFormatedDate(props.item.rioDate)
                    }}
                  </span>
                  
                </div>
              </td>
              <td
                class="text-xs-left pa-2"
                v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                @click="selectMe(props.item)"
              >
                  {{ props.item.rioNote }}
              </td>
              <td
                class="text-xs-left pa-2"
                v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                @click="selectMe(props.item)"
              >
                <v-chip
                  small
                  :text-color="
                    props.item.rioStatus === 'Draft'
                      ? 'black'
                      : 'white'
                  "
                  :color="
                    getChipStatusColor(
                      props.item.rioStatus
                    )
                  "
                >
                  {{ props.item.rioStatus }}
                </v-chip>
              </td>
              
              <template
                v-if="props.item.rioStatus == 'Draft'"
              >
                <td
                  class="text-xs-center pa-2"
                  v-bind:class="{
                    'amber lighten-4': isSelected(props.item),
                  }"
                >
                  <v-btn
                      style="min-width: 25px; height: 25px; margin: 0;"
                      @click="editRequest(props.item)"
                      color="black"
                      small title="Edit"
                  >
                    <v-icon color="white" small
                      >edit</v-icon
                    >
                  </v-btn>
                  <v-btn
                      style="min-width: 25px; height: 25px; margin: 0;"
                      @click="deleteRequest(props.item)"
                      color="red"
                      small title="Hapus"
                  >
                  <v-icon color="white" small>delete</v-icon>
                  </v-btn>
                </td>
              </template>
              <template v-else-if="props.item.rioStatus == 'Send Request'">
                <td
                  class="text-xs-center pa-2 pr-5"
                  v-bind:class="{
                    'amber lighten-4': isSelected(props.item),
                  }"
                >
                <v-btn 
                  :disabled="mainTableLoading || props.item.RequestItemOutVerifiedUserID != '0'"
                  @click="approveRequest(props.item, 'M')" round depressed color="primary" small :outline="props.item.rioStatus != 'Process'"
                  class="d-block mx-auto mb-2"
                > 
                  Verifikasi
                  <v-icon small right dark>done_all</v-icon>
                </v-btn>
                <v-btn 
                  :disabled="mainTableLoading || props.item.RequestItemOutVerifiedUserID == '0'"
                  v-if="props.item.rioStatus === 'Send Request'"
                  @click="approveRequest(props.item, 'K')" round depressed color="primary" small :outline="props.item.rioStatus != 'Process'"
                  class="d-block mx-auto mb-2"
                > 
                  Approve
                  <v-icon small right dark>done_all</v-icon>
                </v-btn>
                <v-btn
                    style="min-width: 25px; height: 25px; margin: 0;"
                    @click="previewRequest(props.item)"
                    color="success"
                    small title="Preview dan Edit Qty"
                    class="d-block mx-auto mb-2"
                >
                <v-icon color="white" small>receipt</v-icon>
                </v-btn>
                </td>
              </template>
              <template v-else>
                <td
                  class="text-xs-center pa-2"
                  v-bind:class="{
                    'amber lighten-4': isSelected(props.item),
                  }"
                ></td>
              </template>
            </template>
          </v-data-table>
        </v-flex>
      </v-layout>
      <v-divider></v-divider>
      <v-pagination
        style="margin-top: 10px; margin-bottom: 10px"
        v-model="mainTableCurrentPage"
        :length="mainTableTotalPage"
      ></v-pagination>
    </v-card>

    <add-request-dialog></add-request-dialog>
    <add-request-detail-dialog></add-request-detail-dialog>
    <approve-dialog></approve-dialog>

    <v-dialog v-model="dialogAlertDeleteRequest" max-width="30%">
      <v-card>
        <v-card-title class="headline grey lighten-2 pt-2 pb-2" primary-title>
          Peringatan !
        </v-card-title>
        <v-card-text class="pt-2 pb-2">
          <v-layout row>
            <v-flex xs12 d-flex>
              <v-layout row>
                <v-flex pb-1 xs12>
                  <v-layout row>
                    <v-flex pt-2 pr-2 xs12>
                      {{ msgAlertDeleteRequest }}
                    </v-flex>
                  </v-layout>
                </v-flex>
              </v-layout>
            </v-flex>
          </v-layout>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" flat @click="dialogAlertDeleteRequest = false">
            Tutup
          </v-btn>
          <v-btn color="red" flat @click="closeAndDeleteRequest()">
            Yakin lah
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

  </div>
</template>

<style scoped>
.date-type-table {
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
}

.table.v-table tbody td,
table.v-table tbody th {
  height: 40px;
}

.table.v-table thead tr {
  height: 40px;
}

.scroll-container {
  scroll-padding: 50px 0 0 50px;
}
</style>

<script>
module.exports = {
  components: {
    "add-request-dialog": httpVueLoader(
      "./addRequestDialog.vue"
    ),
    "add-request-detail-dialog": httpVueLoader("./addRequestDetailDialog.vue"),
    "approve-dialog": httpVueLoader("./approveDialog.vue"),
    "one-dialog-alert": httpVueLoader("../../common/oneDialogAlert.vue"),
    "one-dialog-error": httpVueLoader("../../common/oneDialogError.vue"),
  },
  data() {
    return {
      msgAlertDeleteRequest: "",
      dialogAlertDeleteRequest: false,
      dialogAlertDeleteDetail: false,
      headers: [
        {
          text: "NO RIO",
          align: "center",
          sortable: false,
          value: "no",
          width: "15%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "TANGGAL",
          align: "left",
          sortable: false,
          value: "requestDate",
          width: "15%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "KETERANGAN",
          align: "left",
          sortable: false,
          value: "keterangan",
          width: "40%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "STATUS",
          align: "left",
          sortable: false,
          value: "status",
          width: "20%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "AKSI",
          align: "center",
          sortable: false,
          value: "action",
          width: "10%",
          class: "blue lighten-3 white--text",
        },
      ],
      detailHeaders: [
        {
          text: "NO",
          align: "center",
          sortable: false,
          value: "no",
          width: "5%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "KETERANGAN",
          align: "left",
          sortable: false,
          value: "requestDate",
          width: "25%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "JUMLAH",
          align: "left",
          sortable: false,
          value: "requestDate",
          width: "5%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "HARGA",
          align: "left",
          sortable: false,
          value: "requestDate",
          width: "15%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "SATUAN",
          align: "left",
          sortable: false,
          value: "requestDate",
          width: "20%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "TOTAL HARGA",
          align: "left",
          sortable: false,
          value: "useDate",
          width: "15%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "STATUS",
          align: "left",
          sortable: false,
          value: "status",
          width: "10%",
          class: "blue lighten-3 white--text",
        },
        {
          text: "AKSI",
          align: "left",
          sortable: false,
          value: "action",
          width: "5%",
          class: "blue lighten-3 white--text",
        },
      ],
    };
  },
  mounted() {
    this.$store.dispatch("requester/getlevel");
    this.$store.dispatch("requester/getDivisionUser");
    this.$store.dispatch("requester/search");
  },
  computed: {
    flag() {
      return this.$store.state.requester.flag;
    },
    act() {
      return this.$store.state.requester.act;
    },
    mainTable() {
      return this.$store.state.requester.mainTable;
    },
    detailTable() {
      return this.$store.state.requester.detailTable;
    },
    mainTableLoading() {
      return this.$store.state.requester.mainTableLoadingStatus === 1;
    },
    detailTableLoading() {
      return this.$store.state.requester.detailTableLoadingStatus === 1;
    },
    mainTableTotalPage: {
      get() {
        return this.$store.state.requester.countMainTable;
      },
      set(val) {
        this.$store.commit("requester/updateCountMainTable", val);
      },
    },
    mainTableCurrentPage: {
      get() {
        return this.$store.state.requester.mainTableCurrentPage;
      },
      set(val) {
        this.$store.commit("requester/updateMainTableCurrentPage", val);
        this.$store.commit("requester/updateMainTableLastId", -1);
        this.$store.dispatch("requester/search");
      },
    },
    selectedMainTable: {
      get() {
        return this.$store.state.requester.selectedMainTable;
      },
      set(val) {
        this.$store.commit("updateSelectedMainTable", val);
      },
    },
    menuStartDate: {
      get() {
        return this.$store.state.requester.menuStartDate;
      },
      set(val) {
        this.$store.commit("requester/updateMenuStartDate", val);
      },
    },
    menuEndDate: {
      get() {
        return this.$store.state.requester.menuEndDate;
      },
      set(val) {
        this.$store.commit("requester/updateMenuEndDate", val);
      },
    },
    startDateFormatted() {
      return this.formatDate(this.fStartDate);
    },
    endDateFormatted() {
      return this.formatDate(this.fEndDate);
    },
    dStartDate: {
      get() {
        return this.$store.state.requester.dStartDate;
      },
      set(val) {
        this.$store.commit("requester/updateDStartDate", val);
      },
    },
    dEndDate: {
      get() {
        return this.$store.state.requester.dEndDate;
      },
      set(val) {
        this.$store.commit("requester/updateDEndDate", val);
      },
    },
    fStartDate: {
      get() {
        return this.$store.state.requester.fStartDate;
      },
      set(val) {
        this.$store.commit("requester/updateFStartDate", val);
      },
    },
    fEndDate: {
      get() {
        return this.$store.state.requester.fEndDate;
      },
      set(val) {
        this.$store.commit("requester/updateFEndDate", val);
      },
    },
    fStatus: {
      get() {
        return this.$store.state.requester.fStatus;
      },
      set(val) {
        this.$store.commit("requester/updateFStatus", val);
      },
    },
    statusOptions() {
      return this.$store.state.requester.statusOptions;
    },
    fSearch: {
      get() {
        return this.$store.state.requester.fSearch;
      },
      set(val) {
        this.$store.commit("requester/updateFSearch", val);
      },
    },
    xNumber: {
      get() {
        return this.$store.state.requester.xNumber;
      },
      set(val) {
        this.$store.commit("requester/updateXNumber", val);
      },
    },
    xPRID: {
      get() {
        return this.$store.state.requester.xPRID;
      },
      set(val) {
        this.$store.commit("requester/updateXPRID", val);
      },
    },
    xPRDID: {
      get() {
        return this.$store.state.requester.xPRDID;
      },
      set(val) {
        this.$store.commit("requester/updateXPRDID", val);
      },
    },
    snackbar: {
        get() {
        return this.$store.state.requester.snackbar;
        },
        set(val) {
        this.$store.commit("requester/update_snackbar", val);
        },
    },
    dialog_error: {
      get() {
        return this.$store.state.requester.alertError;
      },
      set(val) {
        this.$store.commit("requester/updateAlertError", val);
      },
    },
    approveLevelID: {
      get() {
        return this.$store.state.requester.approveLevelID;
      },
      set(val) {
        this.$store.commit("requester/updateApproveLevelID", val);
      },
    },
    approveDivisionUserID: {
      get() {
        return this.$store.state.requester.approveDivisionUserID;
      },
      set(val) {
        this.$store.commit("requester/updateApproveDivisionUserID", val);
      },
    },
    msgError() {
      return this.$store.state.requester.errMessage;
    }
  },
  methods: {
    goBack() {
      window.history.back();
      // location.href = "/one-ui/test/vuex/one-accone-approve-all/"
    },
    isApproved(data, type) {
      if (!data) {
        return false
      }

      if (data.rioStatus == 'Process') {
        return false
      }

      if (type == 'M' && data.RequestItemOutApprovedManagerUserID == '0') {
        return true
      } else if (type == 'D' && data.RequestItemOutApprovedDivisionUserID == '0') {
        return true
      } else {
        return false
      }
    },
    approveRequest(val, app){
      this.$store.commit("requester/updateCategoryApprove", app);
      this.$store.commit("requester/updateSelectedMainTable", val);
      let selectedRio = val
      this.$store.commit("requester/updateRegionalOptions", [{S_RegionalID : selectedRio.S_RegionalID, S_RegionalName : selectedRio.S_RegionalName}]);
      this.$store.commit("requester/updateXRegional", {S_RegionalID : selectedRio.S_RegionalID, S_RegionalName : selectedRio.S_RegionalName});
      this.$store.commit("requester/updateBranchOptions", [{M_BranchCode : selectedRio.M_BranchCode, M_BranchName : selectedRio.M_BranchName}]);
      this.$store.commit("requester/updateXBranch", {M_BranchCode : selectedRio.M_BranchCode, M_BranchName : selectedRio.M_BranchName});
      this.$store.commit(
        "requester/updateXDateUse",
        selectedRio.rioDate
      );
      this.$store.dispatch("requester/getWarehouse");
      this.$store.commit("requester/updateSelectedWarehouse",selectedRio.rioWarehouseId);
      this.$store.commit("requester/updateXDescription", selectedRio.rioNote);
      this.$store.dispatch("requester/getDivisionByUser", {
        act: 'edit',
        DivisionID: val.rioDivisionId
      });
      this.$store.commit("requester/update_dialogApprove", true);
      this.$store.dispatch("requester/getDetailRequest", {
        requestId: selectedRio.rioId
      });
      this.$store.commit("requester/update_act_approve", "approve");
    },
    previewRequest(val){
      this.$store.commit("requester/updateSelectedMainTable", val);
      let selectedRio = val
      console.log(selectedRio)
      this.$store.commit("requester/updateRegionalOptions", [{S_RegionalID : selectedRio.S_RegionalID, S_RegionalName : selectedRio.S_RegionalName}]);
      this.$store.commit("requester/updateXRegional", {S_RegionalID : selectedRio.S_RegionalID, S_RegionalName : selectedRio.S_RegionalName});
      this.$store.commit("requester/updateBranchOptions", [{M_BranchCode : selectedRio.M_BranchCode, M_BranchName : selectedRio.M_BranchName}]);
      this.$store.commit("requester/updateXBranch", {M_BranchCode : selectedRio.M_BranchCode, M_BranchName : selectedRio.M_BranchName});
      this.$store.commit(
        "requester/updateXDateUse",
        selectedRio.rioDate
      );
      this.$store.dispatch("requester/getWarehouse");
      this.$store.commit("requester/updateSelectedWarehouse",selectedRio.rioWarehouseId);
      this.$store.commit("requester/updateXDescription", selectedRio.rioNote);
      this.$store.dispatch("requester/getDivisionByUser", {
        act: 'edit',
        DivisionID: val.rioDivisionId
      });
      this.$store.commit("requester/updateDialogRequest", true);
      this.$store.dispatch("requester/getDetailRequest", {
        requestId: selectedRio.rioId,
        division: selectedRio.rioDivisionId,
        warehouseID: selectedRio.rioWarehouseId
      });
      this.$store.commit("requester/updateAct", "preview");
    },
    convertMoney(money){
        return one_money(money)
    },
    isSelected(p) {
      return (
        p.rioId ==
        this.$store.state.requester.selectedMainTable
          .rioId
      );
    },
    selectMe(spr) {
      this.$store.commit("requester/updateSelectedMainTable", spr);
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${day}-${month}-${year}`;
    },
    deFormatedDate(date) {
      if (!date) return null;

      const [day, month, year] = date.split("-");
      return `${year}-${month.padStart(2, "0")}-${day.padStart(2, "0")}`;
    },
    getChipStatusColor(status) {
      switch (status) {
        case "Send Request":
          return "warning";
        case "Process":
          return "success";
        case "Partial":
          return "green";
        case "Rejected":
          return "error";
        case "Completed":
          return "info";
        default:
          return "";
      }
    },
    getChipStatusDetailColor(status) {
      switch (status) {
        case "Pending":
          return "warning";
        case "Ordered":
          return "success";
        case "Received":
          return "info";
        case "Cancelled":
          return "error";
        default:
          return "warning";
      }
    },
    mainTableSearch() {
      this.$store.dispatch("requester/search");
      this.$store.commit("requester/updateSelectedMainTable", {});
      this.$store.commit("requester/updateDetailTable", []);
    },
    resetItemTable() {
      this.$store.commit("requester/updateItems", []);
      this.$store.commit("requester/updateSelectedItem", {});
      this.$store.commit("requester/updateSearchItem", "");
      this.$store.commit("requester/updateLoadingItem", false);
      this.$store.commit("requester/updateItemGroupOptions", []);
      this.$store.commit("requester/updateSelectedItemGroup", {});
      this.$store.commit("requester/updateItemSubGroupOptions", []);
      this.$store.commit("requester/updateSelectedItemSubGroup", {});
      this.$store.commit("requester/updateSelectedWarehouse", "");
    },
    openDialogRequest() {
      let user = one_user()
      this.$store.commit("requester/updateAct", "new");
      this.$store.commit("requester/updateRegionalOptions", [{S_RegionalID : user.S_RegionalID, S_RegionalName : user.S_RegionalName}]);
      this.$store.commit("requester/updateXRegional", {S_RegionalID : user.S_RegionalID, S_RegionalName : user.S_RegionalName});
      this.$store.commit("requester/updateBranchOptions", [{M_BranchCode : user.M_BranchCode, M_BranchName : user.M_BranchName}]);
      this.$store.commit("requester/updateXBranch", {M_BranchCode : user.M_BranchCode, M_BranchName : user.M_BranchName});
      this.$store.commit(
        "requester/updateXDateUse",
        moment(new Date()).format("YYYY-MM-DD")
      );
      this.$store.commit("requester/updateXDescription", "");
      this.$store.commit("requester/updateDialogRequest", true);
      this.$store.commit("requester/updateSelectedMainTable", {});
      this.resetItemTable();
      this.$store.dispatch("requester/getWarehouse");
      this.$store.dispatch("requester/getDivisionByUser", {
        act: 'new',
        DivisionID: ''
      }).then(() => {
        const divisionId = this.$store.state.requester.selectedDivision.DivisionID;
        this.$store.dispatch("requester/getItems", {
          search: "",
          division: divisionId,
          itemGroup: "",
          itemSubGroup: "",
          warehouseID: this.$store.state.requester.selectedWarehouse.WarehouseID
        });
        this.$store.dispatch("requester/getItemGroupSubGroup");
      });
      this.$store.commit("requester/updateDialogItem", false);
      this.$store.commit("requester/updateSelectedItems", []);
    },
    editRequest(val) {
      console.log(val)
      this.$store.commit("requester/updateSelectedMainTable", val);
      this.$store.commit("requester/updateAct", "edit");
      let selectedRio = val
      this.$store.commit("requester/updateRegionalOptions", [{S_RegionalID : selectedRio.S_RegionalID, S_RegionalName : selectedRio.S_RegionalName}]);
      this.$store.commit("requester/updateXRegional", {S_RegionalID : selectedRio.S_RegionalID, S_RegionalName : selectedRio.S_RegionalName});
      this.$store.commit("requester/updateBranchOptions", [{M_BranchCode : selectedRio.M_BranchCode, M_BranchName : selectedRio.M_BranchName}]);
      this.$store.commit("requester/updateXBranch", {M_BranchCode : selectedRio.M_BranchCode, M_BranchName : selectedRio.M_BranchName});
      this.$store.commit(
        "requester/updateXDateUse",
        selectedRio.rioDate
      );
      this.$store.dispatch("requester/getWarehouse");
      this.$store.commit("requester/updateSelectedWarehouse",selectedRio.rioWarehouseId);
      this.$store.commit("requester/updateXDescription", selectedRio.rioNote);
      this.$store.dispatch("requester/getDivisionByUser", {
        act: 'edit',
        DivisionID: val.rioDivisionId
      }).then(() => {
        const divisionId = this.$store.state.requester.selectedDivision.DivisionID;
        this.$store.dispatch("requester/getItems", {
          search: "",
          division: divisionId,
          itemGroup: "",
          itemSubGroup: "",
          warehouseID: this.$store.state.requester.selectedWarehouse.WarehouseID
        });
        this.$store.dispatch("requester/getItemGroupSubGroup");
      });
      this.$store.commit("requester/updateDialogRequest", true);
      this.$store.commit("requester/updateDialogItem", false);
      this.$store.dispatch("requester/getDetailRequest", {
        requestId: selectedRio.rioId,
        division: selectedRio.rioDivisionId,
        warehouseID: selectedRio.rioWarehouseId
      });
    },

    deleteRequest(data) {
      this.xPRID = data.rioId;
      this.xNumber = data.rioNumber;

      this.msgAlertDeleteRequest = `Yakin, mau hapus Request [${data.rioNumber}] ?`;
      this.dialogAlertDeleteRequest = true;
    },
    closeAndDeleteRequest() {
      this.$store.dispatch("requester/deleteRequest", {
        RIOID: this.xPRID,
        RIONumber: this.xNumber,
      });
      this.dialogAlertDeleteRequest = false;
    },
    orderRequest(id, status) {
      if (status === "Draft") {
        this.$store.dispatch("requester/orderRequest", {
          PRID: id,
        });
      }
    },
  },
};
</script>
